#include <stdlib.h>
#include <stdio.h>
#include "basic.h"

static int verbose = 0 ;


typedef struct {
  volatile int x,y,r0;
} common_t ;

typedef struct {
  int id  ;
  common_t *common ;
} ctx_t ;


void *T1(void *_p) {
  ctx_t *p = _p ;
  common_t *q = p->common ;
  q->x = 1 ;
  q->y = 1 ;
  return NULL ;
}

void *T2(void *_p) {
  ctx_t *p = _p ;
  common_t *q = p->common ;
  q->y = 2 ;
  int r0 = q->x ;
  q->r0 = r0 ;
  return NULL ;
}


void run(int size) {
  int k = 0 ;
  int count[3][2] ;
  for (int i = 0 ; i < 3  ; i++)
    for (int j = 0 ; j < 2  ; j++)
      count[i][j] = 0 ;

  for ( ; ; ) {
    common_t c ;
    c.x = 0 ; c.y = 0 ; c.r0 = -1;
    pthread_t th1,th2 ;
    ctx_t a1,a2 ;
    
    a1.id = 1 ; a1.common = &c ; create_thread(&th1,T1,&a1) ;
    a2.id = 2 ; a2.common = &c ; create_thread(&th2,T2,&a2) ;
    join_thread(&th1) ;
    join_thread(&th2) ;
    count[c.y][c.r0]++ ;

    k++ ;
    if (k % size == 0) {
      printf("**********\n") ;
      int nz = 0 ;
      for (int k1 = 1; k1 < 3; k1++)
        for (int k2 = 0 ; k2 < 2 ; k2++) {
          int c = count[k1][k2] ;
          if (c > 0) nz++ ;
          printf("%-6i%c> y=%i; r0=%i\n",c,(k1 == 2 && k2 ==0 ? '*' : ':'),k1,k2) ;
        }
      if (nz == 4) {
        printf("Found all states in %i iterations\n",k) ;
        return ;
      }
    }
  }
}


void usage(char *pgm) {
  fprintf(stderr,"Usage: %s [-v]* [n]\n",pgm) ;
}

int main(int argc, char **argv) {
  char * pgm = argv[0] ;
  int size = SIZE ;
  ++argv ;
  --argc ;
  while (argc > 0) {
    char *arg = *argv ;
    if (*arg == '-') {
      arg++ ;
      if (*arg == 'v') verbose++ ;
      else usage(pgm) ;
    } else {
      break ;
    }
    ++argv;
    --argc ;
  }
  if (argc == 1) {    
    size = atoi(argv[0]) ;
  }
  run(size) ;
  return 0 ;
}
